import piac.SzuperNagyi;
import piac.Vasarlo;
import piac.porteka.Gyumolcs;
import piac.porteka.Gyumolcs.Szin;

public class Main {

  public static void main(String[] args) {
    int meret = Integer.parseInt(args[0]);
    int osszeg = Integer.parseInt(args[1]);
    int i = 2;
    int gyumParams = args.length - 2;
    if (gyumParams % 3 != 0 || gyumParams / 3 < 3) {
      System.out.println("Nem megfelelo parameterezes!");
      System.exit(0);
    }
    Gyumolcs[] gyumolcsok = new Gyumolcs[gyumParams / 3];
    int index = 0;
    while (i < args.length) {
      String fajta = args[i];
      Szin szin = Szin.valueOf(args[i + 1]);
      int ar = Integer.parseInt(args[i + 2]);
      gyumolcsok[index] = new Gyumolcs(fajta, szin, ar);
      System.out.println(gyumolcsok[index]);
      index ++;
      i += 3;
    }
    Vasarlo v = new Vasarlo(meret, osszeg);
    SzuperNagyi n = new SzuperNagyi(meret, osszeg);
    int osszegV = vasarlas(gyumolcsok, v);
    int osszegN = vasarlas(gyumolcsok, n);
    System.out.println(v);
    System.out.println(n);
    if (osszegN < osszegV) {
      System.out.println("A nagyi jobban megrte.");
    } else {
      System.out.println("A nagyi nem rte meg jobban.");
    }
  }
  
  public static int vasarlas(Gyumolcs[] gyumolcsok, Vasarlo vasarlo) {
    int result = vasarlo.getOsszeg();
    for (Gyumolcs gy : gyumolcsok) {
      vasarlo.vasarol(gy);
    }
    return result - vasarlo.getOsszeg();
  }

}
